// #include <SoftwareSerial.h>
// #include <Arduino.h>
#include <Servo.h>

#define RECEPTOR_CH3_PIN 6 // Channel 3 velocity
#define RECEPTOR_CH6_PIN 7 // Channel 6 control Auto/Manual
#define SALIDA_ESC_PIN 0 // to servo or ESC

int ledR = 1;
long baud = 115200;
int vAhora_real = 100;
int vel_real = 0;
volatile int velocidad = 0;
int vAhora = 995;
int dato_switch = 0;
Servo ESC;
unsigned long timeout_pwm_micros = 50000;

void setup()
{
  analogReference(INTERNAL);
  Serial.begin(baud);
  pinMode(RECEPTOR_CH3_PIN, INPUT);
  pinMode(RECEPTOR_CH6_PIN, INPUT);
  ESC.attach(SALIDA_ESC_PIN); // salida al ESC a D10
  pinMode(ledR, OUTPUT);
}

bool switchActivado()
{
  unsigned long value1 = pulseIn(RECEPTOR_CH6_PIN, HIGH, timeout_pwm_micros);
  unsigned long value2 = pulseIn(RECEPTOR_CH6_PIN, HIGH, timeout_pwm_micros);
  if ((value1 > 1200) && (value2 > 1200))
  {
    return false;
  }
  return true;
}

void printSerial()
{
  dato_switch = pulseIn(RECEPTOR_CH6_PIN, HIGH);

  Serial.print("Limitador activado:");
  Serial.print(switchActivado());
  Serial.print(" - ");
  Serial.println(dato_switch);
  Serial.print("Vel: ");
  Serial.print(velocidad);
  Serial.print("  >> ");
  Serial.println(vel_real);
  Serial.print("vAhora: ");
  Serial.print(vAhora);
  Serial.print("  >> ");
  Serial.println(vAhora_real);
}

void loop()
{
  velocidad = pulseIn(RECEPTOR_CH3_PIN, HIGH);
  if (switchActivado())
  {
    ESC.writeMicroseconds(vAhora);
  }
  else
  {
    ESC.writeMicroseconds(velocidad);
    vAhora = velocidad;
  }
  vAhora_real = map(vAhora, 995, 2000, 1000, 50 );
  digitalWrite(ledR, HIGH);   // turn the LED Red on
  delay(vAhora_real);
  digitalWrite(ledR, LOW);   // turn the LED Red off
  delay(vAhora_real);
  printSerial();
}
